// ar.fs
//
// Eric Jardim - ejardim@impa.br
// IMPA - Instituto de Matematica Pura e Aplicada

uniform sampler2D sampler0;
uniform vec2 tc_offset[9];
uniform float lambda, fs;
uniform int mode, fade;


void main(void)
{
    float v = 0.0;
    vec4 p = texture2D(sampler0, gl_TexCoord[0].st + tc_offset[4]);

    if (p.a > 0.0) { 
        gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
        return; 
    }

    if (p.r < 0.0 || p.gb == vec2(0.0, 0.0)) { 
        gl_FragColor = vec4(1.0, 1.0, 1.0, 0.0);
        return; 
    }
    vec2 t1 = p.gb;
    float sx = tc_offset[5].s;
    float sy = tc_offset[7].t;
    vec2 tex_t1 = vec2(sx*t1.x, sy*t1.y);
    
    float q0 = p.r;
    float q1 = texture2D(sampler0, gl_TexCoord[0].st + tex_t1).r;
    float qm1 = texture2D(sampler0, gl_TexCoord[0].st - tex_t1).r;
    float q2 = texture2D(sampler0, gl_TexCoord[0].st + 2.0*tex_t1).r;
    float qm2 = texture2D(sampler0, gl_TexCoord[0].st - 2.0*tex_t1).r;

    float q_plus, q_minus, l;
    if (mode == 0) {
        q_plus = q1 - q0; 
        q_minus = q0 - qm1;
        l = 2.0*q0 - (q1+qm1);
    }
    else if (mode == 1) {
        q_plus = q2 - q0; 
        q_minus = q0 - qm2;
        l = 2.0*q0 - (q2+qm2);
    } 

    if (q_minus > 0.0 && q_plus < 0.0) {
        if (q_minus - q_plus >= 0.0) {
            if (q0 > lambda) {
                v = (q0 - lambda)/ q0;
                v = max(v, l);
                if (fade == 0) v = max(1.0, v);
            }
            else { 
                v = 0.0;
            }
        }
    }
    gl_FragColor = vec4(vec3(1.0-v), 1.0);
}




