// Eric Jardim
// IMPA - Instituto de Matematica Pura e Aplicada

varying vec3 normal, viewdir;
varying vec3 e1, e2;
varying float k1, k2;
varying float q, ndotv, depth;
varying vec2 t1;
uniform float fs;

// compute q1 & t1 per vertex
void main(void)
{
    gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
    normal = normalize(gl_NormalMatrix * gl_Normal);
    viewdir = -normalize((gl_ModelViewMatrix * gl_Vertex).xyz);
    vec3 d = vec3(1.0, 1.0, 1.0);
    vec3 e1 = gl_NormalMatrix * gl_SecondaryColor.rgb;
    //e1 = cross(cross(e1, d),normal);
    //vec3 e2 = gl_NormalMatrix * gl_MultiTexCoord0.rgb;
    vec3 e2 = cross(normal, e1);
    k1 = gl_Color.r;
    k2 = gl_Color.g;

    ndotv = dot(viewdir, normal);
    float u =  dot(viewdir, e1);
    float v =  dot(viewdir, e2);
    float u2 = u*u, v2 = v*v, uv = u*v;
    float csc2theta = 1.0 / (u2 + v2);
    u2 *= csc2theta;
    uv *= csc2theta;
    v2 *= csc2theta;
    float sectheta_minus1 = 1.0 / abs(ndotv) - 1.0;
    float Q11 = k1 * (1.0 + sectheta_minus1 * u2);
    float Q12 = k1 * (      sectheta_minus1 * uv);
    float Q21 = k2 * (      sectheta_minus1 * uv);
    float Q22 = k2 * (1.0 + sectheta_minus1 * v2);
    float QTQ1 = Q11*Q11 + Q21*Q21;
    float QTQ12 = Q11*Q12 + Q21*Q22;
    float QTQ2 = Q12*Q12 + Q22*Q22;

    // find largest eigenvalue of Q^T Q
    float a = QTQ12*QTQ12, b = QTQ2-QTQ1;
    float q1 = 0.5 * (QTQ1 + QTQ2);
    if (q1 > 0.0) q1 += sqrt(a + 0.25*b*b);
    else q1 -= sqrt(a + 0.25*b*b);
    vec2 s1 = (vec2(QTQ2-q1, -QTQ12)); // original
    vec3 w1 = s1.x*e1 + s1.y*e2; // t1 on world coordinates 

    //vec2 t1;
    //float q; 
    q = q1*fs*fs;//pow(2.0, tau)*q1;
    t1 = -normalize(vec2(w1.x, w1.y));
    if (w1.z < 0.0) t1 = -t1;
}

